#ifndef MESSAGING_QT_TP_CHANNEL_GROUP_CHANGE_REASON_H
#define MESSAGING_QT_TP_CHANNEL_GROUP_CHANGE_REASON_H

#include <TelepathyQt/Constants>

namespace messaging
{
namespace qt
{
namespace tp
{
enum ChannelGroupChangeReason
{
    ChannelGroupChangeReasonNone = Tp::ChannelGroupChangeReasonNone,
    ChannelGroupChangeReasonOffline = Tp::ChannelGroupChangeReasonOffline,
    ChannelGroupChangeReasonKicked = Tp::ChannelGroupChangeReasonKicked,
    ChannelGroupChangeReasonBusy = Tp::ChannelGroupChangeReasonBusy,
    ChannelGroupChangeReasonInvited = Tp::ChannelGroupChangeReasonInvited,
    ChannelGroupChangeReasonBanned = Tp::ChannelGroupChangeReasonBanned,
    ChannelGroupChangeReasonError = Tp::ChannelGroupChangeReasonError,
    ChannelGroupChangeReasonInvalidContact = Tp::ChannelGroupChangeReasonInvalidContact,
    ChannelGroupChangeReasonNoAnswer = Tp::ChannelGroupChangeReasonNoAnswer,
    ChannelGroupChangeReasonRenamed = Tp::ChannelGroupChangeReasonRenamed,
    ChannelGroupChangeReasonPermissionDenied = Tp::ChannelGroupChangeReasonPermissionDenied,
    ChannelGroupChangeReasonSeparated = Tp::ChannelGroupChangeReasonSeparated,

    // additional enum values not included in original ChannelGroupChangeReason
    // telepathy enumeration but needed here to provide extra info to client when group
    // is cancelled
    ChannelGroupChangeReasonGone = Tp::ChannelGroupChangeReasonSeparated + 1,
    ChannelGroupChangeReasonRejected = Tp::ChannelGroupChangeReasonSeparated +2
};
}
}
}

#endif // MESSAGING_QT_TP_CHANNEL_GROUP_CHANGE_REASON_H
